To create new wiki account, please join us on #znc at Libera.Chat and ask admins to create a wiki account for you. You can say thanks to spambots for this inconvenience.

Installation: Difference between revisions

From ZNC
Jump to navigation Jump to search
>Yann.soubeyrand
No edit summary
→‎Debian: Move init.d info to a dedicated page. This page is already too big
Line 51: Line 51:
  aptitude build-dep znc
  aptitude build-dep znc
to install build dependencies automatically. Note that sometimes these build-depedencies are outdated and won't work with the current version of ZNC.
to install build dependencies automatically. Note that sometimes these build-depedencies are outdated and won't work with the current version of ZNC.
If you want to run ZNC as a system service you need to (the following commands are to be executed as root):
* create a new system user:
adduser --system --home /var/lib/znc --group znc
* install an init file:
# create a file <code>/etc/init.d/znc</code> with the following content:
#! /bin/sh
### BEGIN INIT INFO
# Provides:          znc
# Required-Start:    $remote_fs $syslog
# Required-Stop:    $remote_fs $syslog
# Default-Start:    2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: ZNC IRC bouncer
# Description:      ZNC is an IRC bouncer
### END INIT INFO
 
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="ZNC daemon"
NAME=znc
DAEMON=/usr/bin/$NAME
DATADIR=/var/lib/znc
DAEMON_ARGS="--datadir=$DATADIR"
PIDDIR=/var/run/znc
PIDFILE=$PIDDIR/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
USER=znc
GROUP=znc
# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0
# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME
# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh
# Define LSB log_* functions.
# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
# and status_of_proc is working.
. /lib/lsb/init-functions
#
# Function that starts the daemon/service
#
do_start()
{
# Return
#  0 if daemon has been started
#  1 if daemon was already running
#  2 if daemon could not be started
if [ ! -d $PIDDIR ]
then
mkdir $PIDDIR
fi
chown $USER:$GROUP $PIDDIR
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test --chuid $USER > /dev/null || return 1
start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --chuid $USER -- $DAEMON_ARGS > /dev/null || return 2
}
#
# Function that stops the daemon/service
#
do_stop()
{
# Return
#  0 if daemon has been stopped
#  1 if daemon was already stopped
#  2 if daemon could not be stopped
#  other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME --chuid $USER
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently.  A last resort is to
# sleep for some time.
start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON --chuid $USER
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}
#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME --chuid $USER
return 0
}
case "$1" in
  start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
  stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
  status)
status_of_proc -p $PIDFILE "$DAEMON" "$NAME" && exit 0 || exit $?
;;
  reload)
log_daemon_msg "Reloading $DESC" "$NAME"
do_reload
log_end_msg $?
;;
  restart)
log_daemon_msg "Restarting $DESC" "$NAME"
do_stop
case "$?" in
  0|1)
do_start
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
  *)
# Failed to stop
log_end_msg 1
;;
esac
;;
  *)
echo "Usage: $SCRIPTNAME {status|start|stop|reload|restart}" >&2
exit 3
;;
esac
:
# give the right permissions to this file:
chmod 755 /etc/init.d/znc
# execute:
update-rc.d znc defaults
* configure ZNC (I didn't find how to do this a better way…):
start-stop-daemon --start --quiet --exec /usr/bin/znc --chuid znc -- --datadir=/var/lib/znc --makeconf
* add the line
PidFile = /var/run/znc/znc.pid
to the global section of the configuration file <code>/var/lib/znc/configs/znc.conf</code>
* start the service:
service znc start
* verify that the service is running:
service znc status


=== Fedora ===
=== Fedora ===

Revision as of 15:38, 11 April 2012

There are several possibilities to install ZNC on your machine. The latest version is always available using the source tarball from http://znc.in/releases.

A ChangeLog is available in the wiki. You can also read more about ZNC's portability.

Which way should I choose for installing ZNC?
If you don't have root access, the only way is to use source tarball. You'll need to use ./configure --prefix=$HOME/znc as described.
If you have root access, you can use either source tarball or the convenient way for your distro. Check section about your distro for details, but be aware that these may contain old versions of ZNC!

Once you have installed ZNC, you can create a config file with znc --makeconf.

Development Versions

Read the git page if you want to get the current development version. Beware that this might have more bugs, be a little unstable and eat your first born. You have been warned!

Source Tarball

Official source tarballs can be found here.

If you want to compile ZNC with OpenSSL support, you need the OpenSSL development package. On Debian/Ubuntu this is called libssl-dev, on CentOS/Fedora/Red Hat it's openssl-devel.

  1. Download the latest source tarball
  2. tar -xzvf znc*.*gz
  3. cd znc*
  4. ./configure
    (use --prefix=$HOME/znc if you don't want a system wide installation or simply don't have root; use --with-openssl=/path/to/openssl if you have a non-standard SSL path)
    (use --enable-extra to configure (and additionally --enable-tcl for modtcl) to include the whole extra package)
  5. make
    (if you are on a dedicated server and your CPU has more than one core, you can use make -jX where X is the number of CPU cores to speed up compilation)
  6. make install

Please note that compiling can take 5-10mins or more.

Once you have installed znc, you can use znc --makeconf to make a configuration file for ZNC.

See the FAQ page if you encounter problems.

Linux

Debian

Debian provides ZNC packages which may be installed using:

aptitude install znc

Warning: Debian Stable has very old version by default. If you want newer version, use http://www.backports.org or compile znc from source.

If you want to build znc from source to get a newer version than Debian provides, you may need the following packages:

build-essential
libssl-dev
libperl-dev

To include c-ares support, also install:

pkg-config
libc-ares-dev

You can use the command

aptitude build-dep znc

to install build dependencies automatically. Note that sometimes these build-depedencies are outdated and won't work with the current version of ZNC.

Fedora

Fedora provides ZNC packages which may be installed using

yum install znc

and

yum install znc-extra

CentOS/Red Hat Enterprise Linux

ZNC packages are available in the Extra Packages for Enterprise Linux repository (EPEL).

To install the EPEL repository, lookup the appropriate EPEL package at http://mirrors.fedoraproject.org/publiclist/EPEL/ then execute the following commands:

rpm -Uvh <link to your package name/architecture>/epel-release-5-4.noarch.rpm
yum update

Once you have EPEL installed, execute:

yum install znc znc-extra

Ubuntu

Ubuntu's ZNC packages

If you want to build znc from source to get a newer version than Ubuntu provides, you need the following packages:

build-essential
libssl-dev
libperl-dev
pkg-config
libc-ares-dev

You can also run the command

sudo apt-get build-dep znc

if you want to get the build depedencies installed automatically.

(Open)SuSE

ZNC is part of the official repositories. To install, use the YaST GUI or install via commandline by typing

yast -i znc

Gentoo

Gentoo provides ZNC packages which may be installed using:

emerge -av net-irc/znc

To install ZNC-Extra and modtcl you need to install znc using:

USE="extras tcl" emerge znc

Several USE Flags can be used for znc:

  • ares: (global/local): enables using the c-ares libary
  • debug: (global): enable debug
  • extras: (global/local): enable additional modules
  • ipv6: global): adds support for ipv6
  • perl (global): adds support writing perl modules
  • ssl (global): enable secure socket layer connections
  • sasl (global): sasl support
  • tcl (global): adds support for writing tcl modules
equery uses znc -a

Will print you a list of USE flags that will be used for znc

Slackware

Latest Slackware SBo Slackbuild

Archlinux

ZNC is part of the archlinux package repository, and can be installed with the following:

pacman -S znc

Additionally you can install the following optional dependencies to add support for additional modules.

  • cyrus-sasl - saslauth module
  • perl - modperl module
  • python - modpython module
  • tcl - modtcl module

rc.d scripts

You may also be interested in rc.d scripts for znc which can be installed with:

pacman -U https://github.com/downloads/kylef/znc-arch/znc-system-wide-1.0-1-any.pkg.tar.xz

You can read more about these scripts here

FreeBSD

ZNC is in FreeBSD ports, just do:

cd /usr/ports/irc/znc
make config
make install clean

or

pkg_add -r znc

Mac OS X

There are two ways to install ZNC on OS X, either using a package manager such as Homebrew or installing it yourself from source. See this blog post for a tutorial on how to compile ZNC from source.

  • NOTE: If you are running on PPC architecture and cannot make the ./configure && make && sudo make install dance work, you'll want to do the following:
  1. Make sure that you're using the --disable-perl switch for configure. Hence: ./configure --prefix=/usr/local --disable-perl
  2. If this still doesn't work, fetch and compile c-ares from source.

Homebrew

Installing Homebrew

For more information about Homebrew see here. The following command will install Homebrew to /usr/local

 ruby -e "$(curl -fsSLk https://gist.github.com/raw/323731/install_homebrew.rb)"

Homebrew requires Xcode and Mac OS X >= 10.5

Installing znc with Homebrew

 brew install znc

Installing znc with MacPorts

 port install znc

Unofficial, user contributed binaries

The following installation sources are created and maintained by users!

RPM

Veit Wahlich created RPM packages and yum repositories for RedHat-based Linux distributions (RHEL/CentOS and Fedora). Version 0.052 is available at http://home.ircnet.de/cru/znc

Microsoft Windows

ZNC as a native Windows program, compiled with Microsoft Visual C++ Includes the main program and around 40 modules. Supports SSL and IPv6.